//
//  Student.m
//  Lab1
//
//  Created by R.J. Aquino on 7/3/13.
//  Copyright (c) 2013 CS50. All rights reserved.
//

#import "Student.h"

@implementation Student

/*
 * Init method
 */
- (Student *)init {
    self = [super init];
    self.major = @"Undeclared";
    return self;
}

- (void)setMajor:(NSString *)major {
    // get valid majors
    NSArray *majors = [Student validMajors];
    
    // check if requested major is valid
    if ([majors containsObject:major])
        _major = [major copy];
    else
        NSLog(@"%@ is not a valid major. %@'s major is still %@", major, self.name, self.major);
}


/*
 * Overwritten setMajor to enfoce valid majors only.
 */
+ (NSArray *)validMajors {
    NSArray *majors = [[NSArray alloc] initWithObjects:@"Math", @"English", @"Computer Science", @"Undeclared",  nil];
    return majors;
}

/*
 * Over written description method (the description method of an NSObject is secretly what's called when you print or NSLog "%@".
 */
- (NSString*)description {
    // get last two digits from year
    int trimmed_year = self.year % 1000 % 100;
    
    // return string (%02d means that years like 2004 will come out 04, up to two digits, padded with zeroes)
    return [NSString stringWithFormat:@"%@ '%02d, %@", self.name, trimmed_year, self.major];
}
@end
